diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/cqa-ff-mac-scheduler.cc ns-3.38/src/lte/model/cqa-ff-mac-scheduler.cc
--- ns-3.37/src/lte/model/cqa-ff-mac-scheduler.cc	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/cqa-ff-mac-scheduler.cc	2023-03-16 20:54:23.664868600 -0700
@@ -45,11 +45,11 @@
 
 /// CGA Type 0 Allocation
 static const int CqaType0AllocationRbg[4] = {
-    10, // RGB size 1
-    26, // RGB size 2
-    63, // RGB size 3
-    110 // RGB size 4
-};      // see table 7.1.6.1-1 of 36.213
+    10,  // RGB size 1
+    26,  // RGB size 2
+    63,  // RGB size 3
+    110, // RGB size 4
+};       // see table 7.1.6.1-1 of 36.213
 
 NS_OBJECT_ENSURE_REGISTERED(CqaFfMacScheduler);
 
@@ -549,7 +549,7 @@
     return (lcActive);
 }
 
-uint8_t
+bool
 CqaFfMacScheduler::HarqProcessAvailability(uint16_t rnti)
 {
     NS_LOG_FUNCTION(this << rnti);
@@ -834,9 +834,9 @@
     // Process DL HARQ feedback
     RefreshHarqProcesses();
     // retrieve past HARQ retx buffered
-    if (m_dlInfoListBuffered.size() > 0)
+    if (!m_dlInfoListBuffered.empty())
     {
-        if (params.m_dlInfoList.size() > 0)
+        if (!params.m_dlInfoList.empty())
         {
             NS_LOG_INFO(this << " Received DL-HARQ feedback");
             m_dlInfoListBuffered.insert(m_dlInfoListBuffered.end(),
@@ -846,7 +846,7 @@
     }
     else
     {
-        if (params.m_dlInfoList.size() > 0)
+        if (!params.m_dlInfoList.empty())
         {
             m_dlInfoListBuffered = params.m_dlInfoList;
         }
@@ -1074,7 +1074,7 @@
                     }
                 }
 
-                if (rlcPduListPerLc.size() > 0)
+                if (!rlcPduListPerLc.empty())
                 {
                     newEl.m_rlcPduList.push_back(rlcPduListPerLc);
                 }
@@ -1124,7 +1124,7 @@
     if (rbgAllocatedNum == numberOfRBGs)
     {
         // all the RBGs are already allocated -> exit
-        if ((ret.m_buildDataList.size() > 0) || (ret.m_buildRarList.size() > 0))
+        if (!ret.m_buildDataList.empty() || !ret.m_buildRarList.empty())
         {
             m_schedSapUser->SchedDlConfigInd(ret);
         }
@@ -1144,12 +1144,12 @@
             // UE already allocated for HARQ or without HARQ process available -> drop it
             if (itRnti != rntiAllocated.end())
             {
-                NS_LOG_DEBUG(this << " RNTI discared for HARQ tx"
+                NS_LOG_DEBUG(this << " RNTI discarded for HARQ tx"
                                   << (uint16_t)(itLogicalChannels->first.m_rnti));
             }
             if (!HarqProcessAvailability(itLogicalChannels->first.m_rnti))
             {
-                NS_LOG_DEBUG(this << " RNTI discared for HARQ id"
+                NS_LOG_DEBUG(this << " RNTI discarded for HARQ id"
                                   << (uint16_t)(itLogicalChannels->first.m_rnti));
             }
             continue;
@@ -1337,9 +1337,9 @@
 
     // while there are more resources available, loop through the users that are grouped by HOL
     // value
-    while (availableRBGs.size() > 0)
+    while (!availableRBGs.empty())
     {
-        if (UeToAmountOfDataToTransfer.size() == 0)
+        if (UeToAmountOfDataToTransfer.empty())
         {
             NS_LOG_INFO("No UEs to be scheduled (no data or CQI==0),");
             break;
@@ -1366,7 +1366,7 @@
             break;
         }
 
-        while (availableRBGs.size() > 0 and itCurrentGroup->second.size() > 0)
+        while (!availableRBGs.empty() && !itCurrentGroup->second.empty())
         {
             bool currentRBchecked = false;
             int currentRB = *(availableRBGs.begin());
@@ -1379,7 +1379,7 @@
             UeToCoitaMetric.clear();
 
             // Iterate through the users and calculate which user will use the best of the current
-            // resource bloc.end()k and assign to that user.
+            // resource block.end() and assign to that user.
             for (std::set<LteFlowId_t>::iterator it = itCurrentGroup->second.begin();
                  it != itCurrentGroup->second.end();
                  it++)
@@ -2040,7 +2040,7 @@
 
     if (nflows == 0)
     {
-        if (ret.m_dciList.size() > 0)
+        if (!ret.m_dciList.empty())
         {
             m_allocationMaps.insert(
                 std::pair<uint16_t, std::vector<uint16_t>>(params.m_sfnSf, rbgAllocationMap));
@@ -2089,7 +2089,8 @@
         if ((itRnti != rntiAllocated.end()) || ((*it).second == 0))
         {
             // UE already allocated for UL-HARQ -> skip it
-            NS_LOG_DEBUG(this << " UE already allocated in HARQ -> discared, RNTI " << (*it).first);
+            NS_LOG_DEBUG(this << " UE already allocated in HARQ -> discarded, RNTI "
+                              << (*it).first);
             it++;
             if (it == m_ceBsrRxed.end())
             {
@@ -2187,7 +2188,7 @@
         else
         {
             // take the lowest CQI value (worst RB)
-            NS_ABORT_MSG_IF((*itCqi).second.size() == 0,
+            NS_ABORT_MSG_IF((*itCqi).second.empty(),
                             "CQI of RNTI = " << (*it).first << " has expired");
             double minSinr = (*itCqi).second.at(uldci.m_rbStart);
             if (minSinr == NO_SINR)
@@ -2469,7 +2470,7 @@
                           << " subframe no. " << (0xF & params.m_sfnSf));
         // get the RNTI from vendor specific parameters
         uint16_t rnti = 0;
-        NS_ASSERT(params.m_vendorSpecificList.size() > 0);
+        NS_ASSERT(!params.m_vendorSpecificList.empty());
         for (std::size_t i = 0; i < params.m_vendorSpecificList.size(); i++)
         {
             if (params.m_vendorSpecificList.at(i).m_type == SRS_CQI_RNTI_VSP)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/cqa-ff-mac-scheduler.h ns-3.38/src/lte/model/cqa-ff-mac-scheduler.h
--- ns-3.37/src/lte/model/cqa-ff-mac-scheduler.h	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/cqa-ff-mac-scheduler.h	2023-03-16 20:54:23.664868600 -0700
@@ -298,9 +298,9 @@
      * \brief Return the availability of free process for the RNTI specified
      *
      * \param rnti the RNTI of the UE to be updated
-     * \return the process id  value
+     * \return the availability
      */
-    uint8_t HarqProcessAvailability(uint16_t rnti);
+    bool HarqProcessAvailability(uint16_t rnti);
 
     /**
      * \brief Refresh HARQ processes according to the timers
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/epc-enb-application.h ns-3.38/src/lte/model/epc-enb-application.h
--- ns-3.37/src/lte/model/epc-enb-application.h	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/epc-enb-application.h	2023-03-16 20:54:23.664868600 -0700
@@ -245,7 +245,7 @@
      * Send a packet to the SGW via the S1-U interface
      *
      * \param packet packet to be sent
-     * \param teid the Tunnel Enpoint IDentifier
+     * \param teid the Tunnel Endpoint IDentifier
      */
     void SendToS1uSocket(Ptr<Packet> packet, uint32_t teid);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/epc-enb-s1-sap.h ns-3.38/src/lte/model/epc-enb-s1-sap.h
--- ns-3.37/src/lte/model/epc-enb-s1-sap.h	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/epc-enb-s1-sap.h	2023-03-16 20:54:23.664868600 -0700
@@ -163,6 +163,9 @@
      */
     MemberEpcEnbS1SapProvider(C* owner);
 
+    // Delete default constructor to avoid misuse
+    MemberEpcEnbS1SapProvider() = delete;
+
     // inherited from EpcEnbS1SapProvider
     void InitialUeMessage(uint64_t imsi, uint16_t rnti) override;
     void DoSendReleaseIndication(uint64_t imsi, uint16_t rnti, uint8_t bearerId) override;
@@ -171,7 +174,6 @@
     void UeContextRelease(uint16_t rnti) override;
 
   private:
-    MemberEpcEnbS1SapProvider();
     C* m_owner; ///< owner class
 };
 
@@ -182,11 +184,6 @@
 }
 
 template <class C>
-MemberEpcEnbS1SapProvider<C>::MemberEpcEnbS1SapProvider()
-{
-}
-
-template <class C>
 void
 MemberEpcEnbS1SapProvider<C>::InitialUeMessage(uint64_t imsi, uint16_t rnti)
 {
@@ -231,13 +228,15 @@
      */
     MemberEpcEnbS1SapUser(C* owner);
 
+    // Delete default constructor to avoid misuse
+    MemberEpcEnbS1SapUser() = delete;
+
     // inherited from EpcEnbS1SapUser
     void InitialContextSetupRequest(InitialContextSetupRequestParameters params) override;
     void DataRadioBearerSetupRequest(DataRadioBearerSetupRequestParameters params) override;
     void PathSwitchRequestAcknowledge(PathSwitchRequestAcknowledgeParameters params) override;
 
   private:
-    MemberEpcEnbS1SapUser();
     C* m_owner; ///< owner class
 };
 
@@ -247,11 +246,6 @@
 {
 }
 
-template <class C>
-MemberEpcEnbS1SapUser<C>::MemberEpcEnbS1SapUser()
-{
-}
-
 template <class C>
 void
 MemberEpcEnbS1SapUser<C>::InitialContextSetupRequest(InitialContextSetupRequestParameters params)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/epc-gtpc-header.cc ns-3.38/src/lte/model/epc-gtpc-header.cc
--- ns-3.37/src/lte/model/epc-gtpc-header.cc	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/epc-gtpc-header.cc	2023-03-16 20:54:23.664868600 -0700
@@ -209,7 +209,7 @@
 }
 
 uint32_t
-GtpcIes::DeserializeImsi(Buffer::Iterator& i, uint64_t& imsi)
+GtpcIes::DeserializeImsi(Buffer::Iterator& i, uint64_t& imsi) const
 {
     uint8_t type = i.ReadU8();
     NS_ASSERT_MSG(type == 1, "Wrong IMSI IE type = " << (uint16_t)type);
@@ -233,7 +233,7 @@
 }
 
 uint32_t
-GtpcIes::DeserializeCause(Buffer::Iterator& i, Cause_t& cause)
+GtpcIes::DeserializeCause(Buffer::Iterator& i, Cause_t& cause) const
 {
     uint8_t type = i.ReadU8();
     NS_ASSERT_MSG(type == 2, "Wrong Cause IE type = " << (uint16_t)type);
@@ -257,7 +257,7 @@
 }
 
 uint32_t
-GtpcIes::DeserializeEbi(Buffer::Iterator& i, uint8_t& epsBearerId)
+GtpcIes::DeserializeEbi(Buffer::Iterator& i, uint8_t& epsBearerId) const
 {
     uint8_t type = i.ReadU8();
     NS_ASSERT_MSG(type == 73, "Wrong EBI IE type = " << (uint16_t)type);
@@ -362,7 +362,7 @@
 }
 
 uint32_t
-GtpcIes::DeserializeBearerTft(Buffer::Iterator& i, Ptr<EpcTft> epcTft)
+GtpcIes::DeserializeBearerTft(Buffer::Iterator& i, Ptr<EpcTft> epcTft) const
 {
     uint8_t type = i.ReadU8();
     NS_ASSERT_MSG(type == 84, "Wrong Bearer TFT IE type = " << (uint16_t)type);
@@ -417,7 +417,7 @@
 }
 
 uint32_t
-GtpcIes::DeserializeUliEcgi(Buffer::Iterator& i, uint32_t& uliEcgi)
+GtpcIes::DeserializeUliEcgi(Buffer::Iterator& i, uint32_t& uliEcgi) const
 {
     uint8_t type = i.ReadU8();
     NS_ASSERT_MSG(type == 86, "Wrong ULI ECGI IE type = " << (uint16_t)type);
@@ -443,7 +443,7 @@
 }
 
 uint32_t
-GtpcIes::DeserializeFteid(Buffer::Iterator& i, GtpcHeader::Fteid_t& fteid)
+GtpcIes::DeserializeFteid(Buffer::Iterator& i, GtpcHeader::Fteid_t& fteid) const
 {
     uint8_t type = i.ReadU8();
     NS_ASSERT_MSG(type == 87, "Wrong FTEID IE type = " << (uint16_t)type);
@@ -468,7 +468,7 @@
 }
 
 uint32_t
-GtpcIes::DeserializeBearerContextHeader(Buffer::Iterator& i, uint16_t& length)
+GtpcIes::DeserializeBearerContextHeader(Buffer::Iterator& i, uint16_t& length) const
 {
     uint8_t type = i.ReadU8();
     NS_ASSERT_MSG(type == 93, "Wrong Bearer Context IE type = " << (uint16_t)type);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/epc-gtpc-header.h ns-3.38/src/lte/model/epc-gtpc-header.h
--- ns-3.37/src/lte/model/epc-gtpc-header.h	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/epc-gtpc-header.h	2023-03-16 20:54:23.664868600 -0700
@@ -188,7 +188,7 @@
 
 /**
  * \ingroup lte
- * GTP-C Information Elemements
+ * GTP-C Information Elements
  */
 class GtpcIes
 {
@@ -229,7 +229,7 @@
      * \param [out] imsi The IMSI
      * \return the number of deserialized bytes
      */
-    uint32_t DeserializeImsi(Buffer::Iterator& i, uint64_t& imsi);
+    uint32_t DeserializeImsi(Buffer::Iterator& i, uint64_t& imsi) const;
 
     /**
      * Serialize the Cause
@@ -243,7 +243,7 @@
      * \param [out] cause The cause
      * \return the number of deserialized bytes
      */
-    uint32_t DeserializeCause(Buffer::Iterator& i, Cause_t& cause);
+    uint32_t DeserializeCause(Buffer::Iterator& i, Cause_t& cause) const;
 
     /**
      * Serialize the eps Bearer Id
@@ -257,7 +257,7 @@
      * \param [out] epsBearerId The eps Bearer Id
      * \return the number of deserialized bytes
      */
-    uint32_t DeserializeEbi(Buffer::Iterator& i, uint8_t& epsBearerId);
+    uint32_t DeserializeEbi(Buffer::Iterator& i, uint8_t& epsBearerId) const;
 
     /**
      * \param i Buffer iterator
@@ -305,7 +305,7 @@
      * \param [out] epcTft The Bearer TFT
      * \return the number of deserialized bytes
      */
-    uint32_t DeserializeBearerTft(Buffer::Iterator& i, Ptr<EpcTft> epcTft);
+    uint32_t DeserializeBearerTft(Buffer::Iterator& i, Ptr<EpcTft> epcTft) const;
 
     /**
      * Serialize the UliEcgi
@@ -319,7 +319,7 @@
      * \param [out] uliEcgi UliEcgi
      * \return the number of deserialized bytes
      */
-    uint32_t DeserializeUliEcgi(Buffer::Iterator& i, uint32_t& uliEcgi);
+    uint32_t DeserializeUliEcgi(Buffer::Iterator& i, uint32_t& uliEcgi) const;
 
     /**
      * Serialize the Fteid_t
@@ -333,7 +333,7 @@
      * \param [out] fteid Fteid
      * \return the number of deserialized bytes
      */
-    uint32_t DeserializeFteid(Buffer::Iterator& i, GtpcHeader::Fteid_t& fteid);
+    uint32_t DeserializeFteid(Buffer::Iterator& i, GtpcHeader::Fteid_t& fteid) const;
 
     /**
      * Serialize the Bearer Context Header
@@ -347,7 +347,7 @@
      * \param [out] length length
      * \return the number of deserialized bytes
      */
-    uint32_t DeserializeBearerContextHeader(Buffer::Iterator& i, uint16_t& length);
+    uint32_t DeserializeBearerContextHeader(Buffer::Iterator& i, uint16_t& length) const;
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/epc-pgw-application.h ns-3.38/src/lte/model/epc-pgw-application.h
--- ns-3.37/src/lte/model/epc-pgw-application.h	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/epc-pgw-application.h	2023-03-16 20:54:23.664868600 -0700
@@ -114,7 +114,7 @@
      * Send a data packet to the internet via the SGi interface of the PGW
      *
      * \param packet packet to be sent
-     * \param teid the Tunnel Enpoint Identifier
+     * \param teid the Tunnel Endpoint Identifier
      */
     void SendToTunDevice(Ptr<Packet> packet, uint32_t teid);
 
@@ -123,7 +123,7 @@
      *
      * \param packet packet to be sent
      * \param sgwS5uAddress the address of the SGW
-     * \param teid the Tunnel Enpoint IDentifier
+     * \param teid the Tunnel Endpoint IDentifier
      */
     void SendToS5uSocket(Ptr<Packet> packet, Ipv4Address sgwS5uAddress, uint32_t teid);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/epc-s11-sap.h ns-3.38/src/lte/model/epc-s11-sap.h
--- ns-3.37/src/lte/model/epc-s11-sap.h	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/epc-s11-sap.h	2023-03-16 20:54:23.664868600 -0700
@@ -135,7 +135,9 @@
             REQUEST_ACCEPTED_PARTIALLY,
             REQUEST_REJECTED,
             CONTEXT_NOT_FOUND
-        } cause; ///< the cause
+        };
+
+        Cause cause; ///< the cause
     };
 
     /**
@@ -257,21 +259,18 @@
      */
     MemberEpcS11SapMme(C* owner);
 
+    // Delete default constructor to avoid misuse
+    MemberEpcS11SapMme() = delete;
+
     // inherited from EpcS11SapMme
     void CreateSessionResponse(CreateSessionResponseMessage msg) override;
     void ModifyBearerResponse(ModifyBearerResponseMessage msg) override;
     void DeleteBearerRequest(DeleteBearerRequestMessage msg) override;
 
   private:
-    MemberEpcS11SapMme();
     C* m_owner; ///< owner class
 };
 
-/**
- * Constructor
- *
- * \param owner the owner class
- */
 template <class C>
 MemberEpcS11SapMme<C>::MemberEpcS11SapMme(C* owner)
     : m_owner(owner)
@@ -279,11 +278,6 @@
 }
 
 template <class C>
-MemberEpcS11SapMme<C>::MemberEpcS11SapMme()
-{
-}
-
-template <class C>
 void
 MemberEpcS11SapMme<C>::CreateSessionResponse(CreateSessionResponseMessage msg)
 {
@@ -319,6 +313,9 @@
      */
     MemberEpcS11SapSgw(C* owner);
 
+    // Delete default constructor to avoid misuse
+    MemberEpcS11SapSgw() = delete;
+
     // inherited from EpcS11SapSgw
     void CreateSessionRequest(CreateSessionRequestMessage msg) override;
     void ModifyBearerRequest(ModifyBearerRequestMessage msg) override;
@@ -326,26 +323,15 @@
     void DeleteBearerResponse(DeleteBearerResponseMessage msg) override;
 
   private:
-    MemberEpcS11SapSgw();
     C* m_owner; ///< owner class
 };
 
-/**
- * Constructor
- *
- * \param owner the owner class
- */
 template <class C>
 MemberEpcS11SapSgw<C>::MemberEpcS11SapSgw(C* owner)
     : m_owner(owner)
 {
 }
 
-template <class C>
-MemberEpcS11SapSgw<C>::MemberEpcS11SapSgw()
-{
-}
-
 template <class C>
 void
 MemberEpcS11SapSgw<C>::CreateSessionRequest(CreateSessionRequestMessage msg)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/epc-s1ap-sap.h ns-3.38/src/lte/model/epc-s1ap-sap.h
--- ns-3.37/src/lte/model/epc-s1ap-sap.h	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/epc-s1ap-sap.h	2023-03-16 20:54:23.664868600 -0700
@@ -202,6 +202,9 @@
      */
     MemberEpcS1apSapMme(C* owner);
 
+    // Delete default constructor to avoid misuse
+    MemberEpcS1apSapMme() = delete;
+
     // inherited from EpcS1apSapMme
     /**
      * Initial UE Message function
@@ -248,7 +251,6 @@
         std::list<ErabSwitchedInDownlinkItem> erabToBeSwitchedInDownlinkList) override;
 
   private:
-    MemberEpcS1apSapMme();
     C* m_owner; ///< owner class
 };
 
@@ -259,11 +261,6 @@
 }
 
 template <class C>
-MemberEpcS1apSapMme<C>::MemberEpcS1apSapMme()
-{
-}
-
-template <class C>
 void
 MemberEpcS1apSapMme<C>::InitialUeMessage(uint64_t mmeUeS1Id,
                                          uint16_t enbUeS1Id,
@@ -318,6 +315,9 @@
      */
     MemberEpcS1apSapEnb(C* owner);
 
+    // Delete default constructor to avoid misuse
+    MemberEpcS1apSapEnb() = delete;
+
     // inherited from EpcS1apSapEnb
     /**
      * Initial context setup request function
@@ -342,7 +342,6 @@
         std::list<ErabSwitchedInUplinkItem> erabToBeSwitchedInUplinkList) override;
 
   private:
-    MemberEpcS1apSapEnb();
     C* m_owner; ///< owner class
 };
 
@@ -352,11 +351,6 @@
 {
 }
 
-template <class C>
-MemberEpcS1apSapEnb<C>::MemberEpcS1apSapEnb()
-{
-}
-
 template <class C>
 void
 MemberEpcS1apSapEnb<C>::InitialContextSetupRequest(uint64_t mmeUeS1Id,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/epc-sgw-application.h ns-3.38/src/lte/model/epc-sgw-application.h
--- ns-3.37/src/lte/model/epc-sgw-application.h	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/epc-sgw-application.h	2023-03-16 20:54:23.664868600 -0700
@@ -135,7 +135,7 @@
      *
      * \param packet packet to be sent
      * \param pgwAddr the address of the PGW
-     * \param teid the Tunnel Enpoint Identifier
+     * \param teid the Tunnel Endpoint Identifier
      */
     void SendToS5uSocket(Ptr<Packet> packet, Ipv4Address pgwAddr, uint32_t teid);
 
@@ -144,7 +144,7 @@
      *
      * \param packet packet to be sent
      * \param enbS1uAddress the address of the eNB
-     * \param teid the Tunnel Enpoint IDentifier
+     * \param teid the Tunnel Endpoint IDentifier
      */
     void SendToS1uSocket(Ptr<Packet> packet, Ipv4Address enbS1uAddress, uint32_t teid);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/epc-ue-nas.cc ns-3.38/src/lte/model/epc-ue-nas.cc
--- ns-3.37/src/lte/model/epc-ue-nas.cc	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/epc-ue-nas.cc	2023-03-16 20:54:23.664868600 -0700
@@ -32,11 +32,13 @@
 NS_LOG_COMPONENT_DEFINE("EpcUeNas");
 
 /// Map each of UE NAS states to its string representation.
-static const std::string g_ueNasStateName[EpcUeNas::NUM_STATES] = {"OFF",
-                                                                   "ATTACHING",
-                                                                   "IDLE_REGISTERED",
-                                                                   "CONNECTING_TO_EPC",
-                                                                   "ACTIVE"};
+static const std::string g_ueNasStateName[EpcUeNas::NUM_STATES] = {
+    "OFF",
+    "ATTACHING",
+    "IDLE_REGISTERED",
+    "CONNECTING_TO_EPC",
+    "ACTIVE",
+};
 
 /**
  * \param s The UE NAS state.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/epc-x2-header.h ns-3.38/src/lte/model/epc-x2-header.h
--- ns-3.37/src/lte/model/epc-x2-header.h	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/epc-x2-header.h	2023-03-16 20:54:23.664868600 -0700
@@ -186,18 +186,18 @@
      */
     uint64_t GetUeAggregateMaxBitRateDownlink() const;
     /**
-     * Set UE Aggregrate Max Bit Rate Downlink function
+     * Set UE Aggregate Max Bit Rate Downlink function
      * \param bitRate the bit rate
      */
     void SetUeAggregateMaxBitRateDownlink(uint64_t bitRate);
 
     /**
-     * Get UE Aggregrate Max Bit Rate Uplik function
+     * Get UE Aggregate Max Bit Rate Uplik function
      * \returns the UE aggregate max bit rate uplink
      */
     uint64_t GetUeAggregateMaxBitRateUplink() const;
     /**
-     * Set UE Aggregrate Max Bit Rate Uplik function
+     * Set UE Aggregate Max Bit Rate Uplik function
      * \param bitRate the bit rate
      */
     void SetUeAggregateMaxBitRateUplink(uint64_t bitRate);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/epc-x2-sap.h ns-3.38/src/lte/model/epc-x2-sap.h
--- ns-3.37/src/lte/model/epc-x2-sap.h	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/epc-x2-sap.h	2023-03-16 20:54:23.664868600 -0700
@@ -232,8 +232,8 @@
         uint16_t sourceCellId;                  ///< source cell ID
         uint16_t targetCellId;                  ///< target cell ID
         uint32_t mmeUeS1apId;                   ///< MME UE S1 AP ID
-        uint64_t ueAggregateMaxBitRateDownlink; ///< UE aggregrate max bit rate downlink
-        uint64_t ueAggregateMaxBitRateUplink;   ///< UE aggregrate max bit rate uplink
+        uint64_t ueAggregateMaxBitRateDownlink; ///< UE aggregate max bit rate downlink
+        uint64_t ueAggregateMaxBitRateUplink;   ///< UE aggregate max bit rate uplink
         std::vector<ErabToBeSetupItem> bearers; ///< bearers
         Ptr<Packet> rrcContext;                 ///< RRC context
     };
@@ -503,6 +503,9 @@
      */
     EpcX2SpecificEpcX2SapProvider(C* x2);
 
+    // Delete default constructor to avoid misuse
+    EpcX2SpecificEpcX2SapProvider() = delete;
+
     //
     // Interface implemented from EpcX2SapProvider
     //
@@ -562,7 +565,6 @@
     void SendHandoverCancel(HandoverCancelParams params) override;
 
   private:
-    EpcX2SpecificEpcX2SapProvider();
     C* m_x2; ///< owner class
 };
 
@@ -573,11 +575,6 @@
 }
 
 template <class C>
-EpcX2SpecificEpcX2SapProvider<C>::EpcX2SpecificEpcX2SapProvider()
-{
-}
-
-template <class C>
 void
 EpcX2SpecificEpcX2SapProvider<C>::SendHandoverRequest(HandoverRequestParams params)
 {
@@ -655,6 +652,9 @@
      */
     EpcX2SpecificEpcX2SapUser(C* rrc);
 
+    // Delete default constructor to avoid misuse
+    EpcX2SpecificEpcX2SapUser() = delete;
+
     //
     // Interface implemented from EpcX2SapUser
     //
@@ -715,7 +715,6 @@
     void RecvHandoverCancel(HandoverCancelParams params) override;
 
   private:
-    EpcX2SpecificEpcX2SapUser();
     C* m_rrc; ///< owner class
 };
 
@@ -725,11 +724,6 @@
 {
 }
 
-template <class C>
-EpcX2SpecificEpcX2SapUser<C>::EpcX2SpecificEpcX2SapUser()
-{
-}
-
 template <class C>
 void
 EpcX2SpecificEpcX2SapUser<C>::RecvHandoverRequest(HandoverRequestParams params)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/eps-bearer.cc ns-3.38/src/lte/model/eps-bearer.cc
--- ns-3.37/src/lte/model/eps-bearer.cc	2022-11-01 17:37:24.551395200 -0700
+++ ns-3.38/src/lte/model/eps-bearer.cc	2023-03-16 20:54:23.664868600 -0700
@@ -81,7 +81,7 @@
     ObjectBase::ConstructSelf(AttributeConstructionList());
 }
 
-EpsBearer::EpsBearer(Qci x, struct GbrQosInformation y)
+EpsBearer::EpsBearer(Qci x, GbrQosInformation y)
     : ObjectBase(),
       qci(x),
       gbrQosInfo(y)
@@ -158,7 +158,7 @@
      */
     static EpsBearer::BearerRequirementsMap ret;
 
-    if (ret.size() == 0)
+    if (ret.empty())
     {
         ret.insert(std::make_pair(GBR_CONV_VOICE, std::make_tuple(true, 2, 100, 1.0e-2, 0, 0)));
         ret.insert(std::make_pair(GBR_CONV_VIDEO, std::make_tuple(true, 4, 150, 1.0e-3, 0, 0)));
@@ -183,7 +183,7 @@
     // Needed to support GCC 4.9. Otherwise, use list constructors (see GetRequirementsRel10)
     static EpsBearer::BearerRequirementsMap ret;
 
-    if (ret.size() == 0)
+    if (ret.empty())
     {
         ret.insert(std::make_pair(GBR_CONV_VOICE, std::make_tuple(true, 20, 100, 1.0e-2, 0, 2000)));
         ret.insert(std::make_pair(GBR_CONV_VIDEO, std::make_tuple(true, 40, 150, 1.0e-3, 0, 2000)));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/eps-bearer.h ns-3.38/src/lte/model/eps-bearer.h
--- ns-3.37/src/lte/model/eps-bearer.h	2022-11-01 17:37:24.551395200 -0700
+++ ns-3.38/src/lte/model/eps-bearer.h	2023-03-16 20:54:23.664868600 -0700
@@ -132,7 +132,9 @@
         DGBR_ITS = 84, ///< Delay-Critical GBR Intelligent Transport Systems (TS 22.261)
         DGBR_ELECTRICITY =
             85, ///< Delay-Critical GBR Electricity Distribution High Voltage (TS 22.261)
-    } qci;      ///< Qos class indicator
+    };
+
+    Qci qci; ///< Qos class indicator
 
     GbrQosInformation gbrQosInfo;    ///< GBR QOS information
     AllocationRetentionPriority arp; ///< allocation retention priority
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/fading-traces/fading_trace_generator.m ns-3.38/src/lte/model/fading-traces/fading_trace_generator.m
--- ns-3.37/src/lte/model/fading-traces/fading_trace_generator.m	2022-11-01 17:37:24.651395600 -0700
+++ ns-3.38/src/lte/model/fading-traces/fading_trace_generator.m	2023-03-16 20:54:23.768869000 -0700
@@ -8,7 +8,7 @@
 delays_urbanETU = [0 50e-9 120e-9 200e-9 230e-9 500e-9 1600e-9 2300e-9 5000e-9];
 Td = 100/c;
 
-% Realtive power of taps (according to 3GPP TS 36.104 Annex B.2)
+% Relative power of taps (according to 3GPP TS 36.104 Annex B.2)
 power_pedestrianEPA = [0.0 -1.0 -2.0 -3.0 -8.0 -17.2 -20.8];
 power_vehicularEVA = [0.0 -1.5 -1.4 -3.6 -0.6 -9.1 -7.0 -12.0 -16.9];
 power_urbanETU = [-1.0 -1.0 -1.0 0.0 0.0 0.0 -3.0 -5.0 -7.0];
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/fdbet-ff-mac-scheduler.cc ns-3.38/src/lte/model/fdbet-ff-mac-scheduler.cc
--- ns-3.37/src/lte/model/fdbet-ff-mac-scheduler.cc	2022-11-01 17:37:24.655395500 -0700
+++ ns-3.38/src/lte/model/fdbet-ff-mac-scheduler.cc	2023-03-16 20:54:23.768869000 -0700
@@ -37,11 +37,11 @@
 
 /// FdBetType0AllocationRbg array
 static const int FdBetType0AllocationRbg[4] = {
-    10, // RGB size 1
-    26, // RGB size 2
-    63, // RGB size 3
-    110 // RGB size 4
-};      // see table 7.1.6.1-1 of 36.213
+    10,  // RGB size 1
+    26,  // RGB size 2
+    63,  // RGB size 3
+    110, // RGB size 4
+};       // see table 7.1.6.1-1 of 36.213
 
 NS_OBJECT_ENSURE_REGISTERED(FdBetFfMacScheduler);
 
@@ -369,7 +369,7 @@
     return (lcActive);
 }
 
-uint8_t
+bool
 FdBetFfMacScheduler::HarqProcessAvailability(uint16_t rnti)
 {
     NS_LOG_FUNCTION(this << rnti);
@@ -598,9 +598,9 @@
     // Process DL HARQ feedback
     RefreshHarqProcesses();
     // retrieve past HARQ retx buffered
-    if (m_dlInfoListBuffered.size() > 0)
+    if (!m_dlInfoListBuffered.empty())
     {
-        if (params.m_dlInfoList.size() > 0)
+        if (!params.m_dlInfoList.empty())
         {
             NS_LOG_INFO(this << " Received DL-HARQ feedback");
             m_dlInfoListBuffered.insert(m_dlInfoListBuffered.end(),
@@ -610,7 +610,7 @@
     }
     else
     {
-        if (params.m_dlInfoList.size() > 0)
+        if (!params.m_dlInfoList.empty())
         {
             m_dlInfoListBuffered = params.m_dlInfoList;
         }
@@ -838,7 +838,7 @@
                     }
                 }
 
-                if (rlcPduListPerLc.size() > 0)
+                if (!rlcPduListPerLc.empty())
                 {
                     newEl.m_rlcPduList.push_back(rlcPduListPerLc);
                 }
@@ -888,7 +888,7 @@
     if (rbgAllocatedNum == rbgNum)
     {
         // all the RBGs are already allocated -> exit
-        if ((ret.m_buildDataList.size() > 0) || (ret.m_buildRarList.size() > 0))
+        if (!ret.m_buildDataList.empty() || !ret.m_buildRarList.empty())
         {
             m_schedSapUser->SchedDlConfigInd(ret);
         }
@@ -909,11 +909,11 @@
             // UE already allocated for HARQ or without HARQ process available -> drop it
             if (itRnti != rntiAllocated.end())
             {
-                NS_LOG_DEBUG(this << " RNTI discared for HARQ tx" << (uint16_t)(*itFlow).first);
+                NS_LOG_DEBUG(this << " RNTI discarded for HARQ tx" << (uint16_t)(*itFlow).first);
             }
             if (!HarqProcessAvailability((*itFlow).first))
             {
-                NS_LOG_DEBUG(this << " RNTI discared for HARQ id" << (uint16_t)(*itFlow).first);
+                NS_LOG_DEBUG(this << " RNTI discarded for HARQ id" << (uint16_t)(*itFlow).first);
             }
             continue;
         }
@@ -952,7 +952,7 @@
         }
     }
 
-    if (estAveThr.size() != 0)
+    if (!estAveThr.empty())
     {
         // Find UE with largest priority metric
         for (it = estAveThr.begin(); it != estAveThr.end(); it++)
@@ -1460,7 +1460,7 @@
 
     if (nflows == 0)
     {
-        if (ret.m_dciList.size() > 0)
+        if (!ret.m_dciList.empty())
         {
             m_allocationMaps.insert(
                 std::pair<uint16_t, std::vector<uint16_t>>(params.m_sfnSf, rbgAllocationMap));
@@ -1506,7 +1506,8 @@
         if ((itRnti != rntiAllocated.end()) || ((*it).second == 0))
         {
             // UE already allocated for UL-HARQ -> skip it
-            NS_LOG_DEBUG(this << " UE already allocated in HARQ -> discared, RNTI " << (*it).first);
+            NS_LOG_DEBUG(this << " UE already allocated in HARQ -> discarded, RNTI "
+                              << (*it).first);
             it++;
             if (it == m_ceBsrRxed.end())
             {
@@ -1577,7 +1578,7 @@
         {
             // unable to allocate new resource: finish scheduling
             m_nextRntiUl = (*it).first;
-            if (ret.m_dciList.size() > 0)
+            if (!ret.m_dciList.empty())
             {
                 m_schedSapUser->SchedUlConfigInd(ret);
             }
@@ -1596,7 +1597,7 @@
         else
         {
             // take the lowest CQI value (worst RB)
-            NS_ABORT_MSG_IF((*itCqi).second.size() == 0,
+            NS_ABORT_MSG_IF((*itCqi).second.empty(),
                             "CQI of RNTI = " << (*it).first << " has expired");
             double minSinr = (*itCqi).second.at(uldci.m_rbStart);
             if (minSinr == NO_SINR)
@@ -1876,7 +1877,7 @@
     case UlCqi_s::SRS: {
         // get the RNTI from vendor specific parameters
         uint16_t rnti = 0;
-        NS_ASSERT(params.m_vendorSpecificList.size() > 0);
+        NS_ASSERT(!params.m_vendorSpecificList.empty());
         for (std::size_t i = 0; i < params.m_vendorSpecificList.size(); i++)
         {
             if (params.m_vendorSpecificList.at(i).m_type == SRS_CQI_RNTI_VSP)
